#include "base.as"
#include "races.as"

bool wasRepaired = false;
racesManager races();

void createRaces()
{
	// We add 1 race to the map
	
	double[][]	DiveKing = {

		{77.4764, 18.2, 21.9217, 0, 66.8982, 0},
		{67.3556, 20.2, 56.573, 0, 112.162, 0},
		{110.431, 18.2, 92.3012, 0, 174.041, 0},
		{164.031, 12.2, 118.807, 0, 179.656, 0},
		{256.076, 18.2, 46.2452, 0, 225.722, 0},
		{323.563, 18.2, 9.32578, 0, 153.644, 0},
		{337.306, 18.2, 60.8545, 0, 46.1571, 0},
		{310.036, 20.2, 110.454, 0, 65.8669, 0},
		{293.657, 19.5, 150.532, 0, 31.604, 0},
		{273.792, 20.2, 196.597, 0, 75.4926, 0},
		{260.219, 20.2, 303.79, 0, 100.817, 0},
		{323.447, 14.2, 342.429, 0, 232.941, 0},
		{321.21, 22.2, 221.879, 0, 2.54465, 0},
		{217.019, 8.2, 214.564, 0, 23.6296, 0},
		{115.977, 8.2, 305.642, 0, 43.9123, 0},
		{14.2898, 18.2, 351.105, 0, 344.096, 0},
		{6.21161, 18.2, 269.217, 0, 230.696, 0},
		{22.2673, 20.2, 191.459, 0, 307.931, 0},
		{28.1149, 14.2, 110.682, 0, 218.321, 0}
};


		
	//               race name   coordinates   #laps       checkpoint object     startline object          finishline object
	// races.addRace("Ladoga trophy", mountainRoad, races.LAPS_NoLaps, "dgchk", "dgstartgreen");
	races.addRace("DiveKing", DiveKing, races.LAPS_NoLaps, "e6acUID_Torus", "e6acUID_Torusstart", "e6acUID_Torusstart");

	// the above code works perfectly, but lets demonstrate another possiblity:
	// int myRaceID = races.addNewEmptyRace();
	// races.setRaceName(myRaceID, "drag race");
	// races.setLaps(myRaceID, races.LAPS_NoLaps);
	// races.addCheckpoint(myRaceID, 0, "new-checkpoint-start", coords4[0]);
	// races.addCheckpoint(myRaceID, 1, "new-checkpoint",       coords4[1]);
	// This is more code, but note how this allows much more flexibility
	// We could for example have added a second checkpoint at position 0.
	// That would have given use 2 start lines for the same race.
	// Another thing that we could do is using another object for each checkpoint.

	
	// register a callback function, that will be called every time a race starts
	
	//races.setCallback("RaceStart", on_raceStart);

	// add a no entry sign at the start of the mud race, to indicate which way you should start
	// game.spawnObject("sign-noentry", "sign-noentry1", vector3(807.118, 5.09987, 1119.97), vector3(0.0, -90.0, 0.0), "", false);
	// game.spawnObject("sign-noentry", "sign-noentry2", vector3(807.118, 5.09987, 1108.97), vector3(0.0, -90.0, 0.0), "", false);

	// add a cancel point for all races (raceID=-1)
	
	//double[][] coords6 = {{ 798.592, 368.514, 629.076, 0, 86.0925, 0}} ;
	//races.addCancelPoint(-1, "dgstartgreen", coords6[0], on_cancelPoint);
	
	// add the pitstop event
	// game.spawnObject("trucktrigger", "pitstop", vector3(883.356262, 0.340250, 1302.838745), vector3(0.000010, 0.000000, 0.000000), "PitStopEvent", false);

}

void main()
{
	createRaces();
	
	float a = 0.123;
	game.log("foobar: " + a);
	
	string api_return;
	dictionary dict;
	dict.set("one", 1);
	dict.set("two", "test-string");
	dict.set("time", 1.12354);
	
	int res = game.useOnlineAPI("/submit_race_time/", dict, api_return);
	game.log("useOnlineAPI returned: " + res);
	game.log("useOnlineAPI return string: " + api_return);
}

// called when a truck touches the pitstop object
void PitStopEvent(int trigger_type, string inst, string box, int nodeid)
{
	if(wasRepaired) return;

	// get current truck
	BeamClass @b = game.getCurrentTruck();
	if(b.getWheelSpeed() > 0.1)
	{
		game.flashMessage("stop truck to repair it", 3, -1);
	} else
	{
		game.flashMessage("Repairing...", 3, -1);
		b.reset(true);
		wasRepaired = true;
	}
	
	// TODO: reset wasRepaired at some point ...
	
	// old repair style, requires the truck to be in the event box, otherwise its not found
	//game.repairVehicle(inst, box, true);
}

void eventCallback(int eventnum, int value)
{
	races.eventCallback(eventnum, value);
}

void on_raceStart(dictionary@ info)
{
	game.log("Race started and callback works");
	// you could edit the flashMessage or so, or lock a race, or whatever
}

void on_cancelPoint(dictionary@ info)
{
	game.flashMessage("Race aborted.", 4, -1);
}